package org.ow2.petals.binding.soap.listener.incoming;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.description.AxisEndpoint;
import org.apache.axis2.description.AxisOperation;
import org.apache.axis2.description.AxisService;
import org.apache.axis2.description.WSDL2Constants;
import org.apache.axis2.dispatchers.AddressingBasedDispatcher;

public class PetalsAddresingBasedDispatcher extends AddressingBasedDispatcher {

    @Override
    public AxisOperation findOperation(AxisService service, MessageContext messageContext)
            throws AxisFault {
        PetalsAxisService petalsAxisService = (PetalsAxisService) messageContext.getAxisService();

        if (!petalsAxisService.wasAlreadyInitializedFromWSDL()) {
            petalsAxisService.initFromWSDL();

            AxisEndpoint axisEndpoint = (AxisEndpoint) messageContext
                    .getProperty(WSDL2Constants.ENDPOINT_LOCAL_NAME);
            if (axisEndpoint != null) {
                axisEndpoint = petalsAxisService.getEndpoint(axisEndpoint.getName());
                messageContext.setProperty(WSDL2Constants.ENDPOINT_LOCAL_NAME, axisEndpoint);
            }
        }

        return super.findOperation(service, messageContext);
    }
}
